//
//  expr.hpp
//  JDBDynamicModule
//
//  Created by 李格非 on 2020/11/5.
//

#ifndef expr_hpp
#define expr_hpp

#include <stdio.h>
#include "DYNOCInterface.h"

typedef enum {
    EXPRESSION_ERROR_NONE = 0,
    EXPRESSION_ERROR_EXPECT_DIGIT,
    EXPRESSION_ERROR_DIVISION_BY_ZERO,
    EXPRESSION_ERROR_REMAINDER_BY_ZERO,
    EXPRESSION_ERROR_EXPECT_OPEN_PARENTHESIS,
    EXPRESSION_ERROR_EXPECT_CLOSE_PARENTHESIS,
    EXPRESSION_ERROR_EXPECT_ID,
    EXPRESSION_ERROR_EXPECT_COMMA,
    EXPRESSION_ERROR_EXPECT_COLON,
    EXPRESSION_ERROR_UNKNOW_FUNCTION,
    EXPRESSION_ERROR_EXPECT_END,
    EXPRESSION_ERROR_UNKNOW_TOKEN,
}ERROR_TYPE;

//double calculate(const char *n, int *error);
double eval(const char *expStr);

double eval_with_variables(const char *expStr, Map vars);


#endif /* expr_hpp */
