//
//  DYNOCInterface.h
//  Pods
//
//  Created by 李格非 on 2020/11/11.
//

#ifndef DYNOCInterface_h
#define DYNOCInterface_h

#include <map>
#include <string>
#include <vector>

using namespace std;

// 原生通信数据类型
typedef enum : unsigned int {
    VariableType_Unknown,
    
    VariableType_Int,
    VariableType_Double,
    VariableType_String,
    VariableType_Array,
    VariableType_Map,
} VariableType;



// 数据结构体
typedef struct variable {
    VariableType type;
    
    int intValue;
    double doubleValue;
    char* stringValue;
    //TODO:补齐容器类型
//    vector<variable> array;
//    map<variable, variable> map;
//
//    bool operator < (const variable &x) const
//    {
//        switch (type) {
//            case VariableType_Int: return intValue < x.intValue;
//            case VariableType_Double: return doubleValue < x.doubleValue;
//                return 0;

//        }
//    }
} variable;

typedef map<string, variable> Map;

#endif /* DYNOCInterface_h */
